> ## Documentation Index
> Fetch the complete documentation index at: https://docs.getcargo.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Execute action

> Execute an orchestration action



## OpenAPI

````yaml https://api.getcargo.io/openapi.json post /orchestration/actions/execute
openapi: 3.1.0
info:
  title: Cargo API
  version: 1.0.0
  description: Cargo Platform API v1
servers:
  - url: https://api.getcargo.io/v1
    description: Cargo API
security:
  - bearerAuth: []
paths:
  /orchestration/actions/execute:
    post:
      tags:
        - Orchestration - Actions
      summary: Execute action
      description: Execute an orchestration action
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                action:
                  allOf:
                    - type: object
                      properties:
                        config:
                          type: object
                          propertyNames:
                            type: string
                          additionalProperties: {}
                        retry:
                          type: object
                          properties:
                            maximumAttempts:
                              type: number
                            initialInterval:
                              type: number
                            backoffCoefficient:
                              type: number
                      required:
                        - config
                    - anyOf:
                        - type: object
                          properties:
                            kind:
                              type: string
                              enum:
                                - native
                            actionSlug:
                              type: string
                          required:
                            - kind
                            - actionSlug
                        - type: object
                          properties:
                            kind:
                              type: string
                              enum:
                                - connector
                            connectorUuid:
                              type: string
                            integrationSlug:
                              type: string
                            actionSlug:
                              type: string
                          required:
                            - kind
                            - integrationSlug
                            - actionSlug
                        - type: object
                          properties:
                            kind:
                              type: string
                              enum:
                                - tool
                            toolUuid:
                              type: string
                            templateSlug:
                              type: string
                            releaseUuid:
                              type: string
                            waitUntilFinished:
                              type: boolean
                          required:
                            - kind
                        - type: object
                          properties:
                            kind:
                              type: string
                              enum:
                                - agent
                            agentUuid:
                              type: string
                            templateSlug:
                              type: string
                            releaseUuid:
                              type: string
                            waitUntilFinished:
                              type: boolean
                          required:
                            - kind
                  title: Action
                  description: Action to execute.
                data:
                  title: Data
                  description: Input data for the run.
              required:
                - action
              additionalProperties: false
              title: Request body
              description: Request body schema.
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                type: object
                properties:
                  run:
                    type: object
                    properties:
                      uuid:
                        type: string
                      workspaceUuid:
                        type: string
                      workflowUuid:
                        type: string
                      userUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      releaseUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      nodes:
                        anyOf:
                          - type: array
                            items:
                              allOf:
                                - type: object
                                  properties:
                                    uuid:
                                      type: string
                                      format: uuid
                                      pattern: >-
                                        ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-4[0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12})$
                                    slug:
                                      type: string
                                      pattern: ^\w+$
                                    name:
                                      type: string
                                    config:
                                      type: object
                                      propertyNames:
                                        type: string
                                      additionalProperties: {}
                                    description:
                                      type: string
                                    retry:
                                      type: object
                                      properties:
                                        maximumAttempts:
                                          type: number
                                        initialInterval:
                                          type: number
                                        backoffCoefficient:
                                          type: number
                                      additionalProperties: false
                                    childrenUuids:
                                      type: array
                                      items:
                                        anyOf:
                                          - type: string
                                          - type: 'null'
                                    fallbackChildUuid:
                                      type: string
                                    fallbackOnFailure:
                                      type: boolean
                                    position:
                                      type: object
                                      properties:
                                        x:
                                          type: number
                                        'y':
                                          type: number
                                      required:
                                        - x
                                        - 'y'
                                      additionalProperties: false
                                  required:
                                    - uuid
                                    - slug
                                    - config
                                    - childrenUuids
                                    - fallbackOnFailure
                                    - position
                                  additionalProperties: false
                                - anyOf:
                                    - type: object
                                      properties:
                                        kind:
                                          type: string
                                          enum:
                                            - native
                                        actionSlug:
                                          type: string
                                      required:
                                        - kind
                                        - actionSlug
                                      additionalProperties: false
                                    - type: object
                                      properties:
                                        kind:
                                          type: string
                                          enum:
                                            - connector
                                        connectorUuid:
                                          type: string
                                        integrationSlug:
                                          type: string
                                        actionSlug:
                                          type: string
                                      required:
                                        - kind
                                        - integrationSlug
                                        - actionSlug
                                      additionalProperties: false
                                    - type: object
                                      properties:
                                        kind:
                                          type: string
                                          enum:
                                            - tool
                                        toolUuid:
                                          type: string
                                        templateSlug:
                                          type: string
                                        releaseUuid:
                                          type: string
                                        waitUntilFinished:
                                          type: boolean
                                      required:
                                        - kind
                                      additionalProperties: false
                                    - type: object
                                      properties:
                                        kind:
                                          type: string
                                          enum:
                                            - agent
                                        agentUuid:
                                          type: string
                                        templateSlug:
                                          type: string
                                        releaseUuid:
                                          type: string
                                        waitUntilFinished:
                                          type: boolean
                                      required:
                                        - kind
                                      additionalProperties: false
                          - type: 'null'
                      batchUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      traceUuid:
                        type: string
                      temporalWorkflowId:
                        type: string
                      recordId:
                        type: string
                      recordTitle:
                        type: string
                      contextS3Filename:
                        type: string
                      computedConfigsS3Filename:
                        type: string
                      parentUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      parentNodeUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      parentBatchUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      parentAgentUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      parentChatUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      parentMessageUuid:
                        anyOf:
                          - type: string
                          - type: 'null'
                      isGroupParent:
                        anyOf:
                          - type: boolean
                          - type: 'null'
                      status:
                        type: string
                        enum:
                          - idle
                          - pending
                          - running
                          - success
                          - error
                          - cancelling
                          - cancelled
                          - skipped
                      errorMessage:
                        anyOf:
                          - type: string
                          - type: 'null'
                      executions:
                        type: array
                        items:
                          allOf:
                            - type: object
                              properties:
                                nodeUuid:
                                  type: string
                                nodeSlug:
                                  type: string
                                nodeBatchUuid:
                                  anyOf:
                                    - type: string
                                    - type: 'null'
                                nodeRunUuid:
                                  anyOf:
                                    - type: string
                                    - type: 'null'
                                nodeMessageUuid:
                                  anyOf:
                                    - type: string
                                    - type: 'null'
                                nodeChildIndex:
                                  anyOf:
                                    - type: number
                                    - type: 'null'
                                nextNodeUuid:
                                  anyOf:
                                    - type: string
                                    - type: 'null'
                                status:
                                  type: string
                                  enum:
                                    - pending
                                    - success
                                    - error
                                errorMessage:
                                  anyOf:
                                    - type: string
                                    - type: 'null'
                                title:
                                  anyOf:
                                    - type: string
                                    - type: 'null'
                                iconUrl:
                                  anyOf:
                                    - type: string
                                    - type: 'null'
                                creditsUsedCount:
                                  type: number
                                nodeWaitUntilFinished:
                                  type: boolean
                              required:
                                - nodeUuid
                                - nodeSlug
                                - nodeBatchUuid
                                - nodeRunUuid
                                - nodeMessageUuid
                                - nodeChildIndex
                                - nextNodeUuid
                                - status
                                - errorMessage
                                - title
                                - iconUrl
                                - creditsUsedCount
                                - nodeWaitUntilFinished
                              additionalProperties: false
                            - anyOf:
                                - type: object
                                  properties:
                                    nodeKind:
                                      type: string
                                      const: native
                                    nodeActionSlug:
                                      type: string
                                  required:
                                    - nodeKind
                                    - nodeActionSlug
                                  additionalProperties: false
                                - type: object
                                  properties:
                                    nodeKind:
                                      type: string
                                      const: connector
                                    nodeActionSlug:
                                      type: string
                                    nodeConnectorUuid:
                                      type: string
                                    nodeIntegrationSlug:
                                      type: string
                                  required:
                                    - nodeKind
                                    - nodeActionSlug
                                    - nodeConnectorUuid
                                    - nodeIntegrationSlug
                                  additionalProperties: false
                                - type: object
                                  properties:
                                    nodeKind:
                                      type: string
                                      const: tool
                                    nodeToolUuid:
                                      type: string
                                    nodeReleaseUuid:
                                      anyOf:
                                        - type: string
                                        - type: 'null'
                                  required:
                                    - nodeKind
                                    - nodeToolUuid
                                    - nodeReleaseUuid
                                  additionalProperties: false
                                - type: object
                                  properties:
                                    nodeKind:
                                      type: string
                                      const: agent
                                    nodeAgentUuid:
                                      type: string
                                    nodeReleaseUuid:
                                      anyOf:
                                        - type: string
                                        - type: 'null'
                                  required:
                                    - nodeKind
                                    - nodeAgentUuid
                                    - nodeReleaseUuid
                                  additionalProperties: false
                      createdAt:
                        type: string
                      updatedAt:
                        type: string
                      finishedAt:
                        anyOf:
                          - type: string
                          - type: 'null'
                      deletedAt:
                        anyOf:
                          - type: string
                          - type: 'null'
                    required:
                      - uuid
                      - workspaceUuid
                      - workflowUuid
                      - userUuid
                      - releaseUuid
                      - nodes
                      - batchUuid
                      - traceUuid
                      - temporalWorkflowId
                      - recordId
                      - recordTitle
                      - contextS3Filename
                      - computedConfigsS3Filename
                      - parentUuid
                      - parentNodeUuid
                      - parentBatchUuid
                      - parentAgentUuid
                      - parentChatUuid
                      - parentMessageUuid
                      - isGroupParent
                      - status
                      - errorMessage
                      - executions
                      - createdAt
                      - updatedAt
                      - finishedAt
                      - deletedAt
                    additionalProperties: false
                    title: Run
                    description: Created run details.
                required:
                  - run
                additionalProperties: false
        '400':
          description: Bad request
        '401':
          description: Unauthorized
        '404':
          description: Not found
        '500':
          description: Internal server error
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````